<?php
/**
 * $Horde: whups/mybugs.php,v 1.28 2006/01/01 21:12:13 jan Exp $
 *
 * Copyright 2002-2006 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

@define('WHUPS_BASE', dirname(__FILE__));
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Query.php';
require_once WHUPS_TEMPLATES . '/searchresults.inc';
require_once WHUPS_TEMPLATES . '/savedsearches.inc';
require_once WHUPS_TEMPLATES . '/savedqueries.inc';

if (!Auth::getAuth()) {
    header('Location: ' . Horde::applicationUrl('search.php', true));
    exit;
}

$values = Whups::getSearchResultColumns(WHUPS_RESULTS_MYBUGS);

// Update sorting preferences.
if (Util::getFormData('sortby') !== null) {
    $prefs->setValue('sortby', Util::getFormData('sortby'));
}
if (Util::getFormData('sortdir') !== null) {
    $prefs->setValue('sortdir', Util::getFormData('sortdir'));
}

// Fetch all unresolved tickets assigned to the current user.
$info = array('owner' => Whups::getOwnerCriteria(Auth::getAuth()),
              'nores' => true);

$atickets = $whups->getTicketsByProperties($info);
if (is_a($atickets, 'PEAR_Error')) {
    $notification->push(sprintf(_("There was an error listing your assigned tickets: %s"), $atickets->getMessage()), 'horde.error');
} else {
    if (count($atickets)) {
        Whups::sortTickets($atickets);
    }
    $my_results = &new SearchResults(_("My Assigned Tickets"));
}

// Fetch all unresolved tickets requested by the current user, minus
// any assigned to the current user.
$info = array('requester' => Auth::getAuth(),
              'notowner' => 'user:' . Auth::getAuth(),
              'nores' => true);

$rtickets = $whups->getTicketsByProperties($info);
if (is_a($rtickets, 'PEAR_Error')) {
    $notification->push(sprintf(_("There was an error listing your open requests: %s"), $rtickets->getMessage()), 'horde.error');
} else {
    if (count($rtickets)) {
        Whups::sortTickets($rtickets);
    }
    $open_results = &new SearchResults(_("My Open Requests"));
}

$refresh_time = 300;
$refresh_url = Horde::selfUrl();
$title = sprintf(_("My %s"), $registry->get('name'));
require WHUPS_TEMPLATES . '/common-header.inc';
require WHUPS_TEMPLATES . '/menu.inc';

if (!empty($my_results)) {
    $my_results->results($atickets, $values);
}

if (!empty($open_results)) {
    $open_results->results($rtickets, $values);
}

$r = &new Horde_Form_Renderer();
$mysearches = &new SavedSearches();
$mysearches->render(_("My QuickSearches"), $r, $whups->getUserSearches(Auth::getAuth()));

$qManager = &Whups_QueryManager::singleton();
$myqueries = &new SavedQueries();
$myqueries->render(_("My Queries"), $r, $qManager->listShares(Auth::getAuth()));

require $registry->get('templates', 'horde') . '/common-footer.inc';
