#!/usr/local/bin/php
<?php
/**
 * $Horde: whups/scripts/upgrades/2005-04-24_convert_queries.php,v 1.1 2005/04/25 02:43:02 chuck Exp $
 *
 * This is a script to update the whups_logs table to store numeric
 * log values as well as strings, effective 2004-12-18.
 */

@define('AUTH_HANDLER', true);
@define('HORDE_BASE', dirname(__FILE__) . '/../../..');
@define('WHUPS_BASE', HORDE_BASE . '/whups');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();
$cli = &Horde_CLI::singleton();

require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Query.php';

$qManager = &Whups_QueryManager::singleton();
$db = &$whups->_db;

$rows = $db->getAll('SELECT * FROM whups_users_queries', DB_FETCHMODE_ASSOC);
foreach ($rows as $row) {
    $query = &$qManager->newQuery();
    $query->set('name', $row['query_name']);
    $query->set('owner', $row['user_uid']);

    $obj = @unserialize($row['query_object']);
    if ($obj === false) {
        continue;
    }
    $query->set('currentTicketType', $obj[0]);
    $query->data['query'] = $obj[1];
    $query->data['parameters'] = $obj[2];

    echo $query->save() . "\n";
}
